VERSION 5.00
Begin VB.Form frmDesktop 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   0  'None
   ClientHeight    =   3675
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5025
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   Icon            =   "frmDesktop.frx":0000
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   245
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   335
   ShowInTaskbar   =   0   'False
   WindowState     =   2  'Maximized
   Begin VB.PictureBox picIcon 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   480
      Index           =   0
      Left            =   360
      OLEDropMode     =   1  'Manual
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   2
      Top             =   0
      Width           =   480
      Visible         =   0   'False
   End
   Begin VB.PictureBox picTemp 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   480
      Left            =   3690
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   0
      Top             =   4680
      Width           =   480
      Visible         =   0   'False
   End
   Begin VB.Image imgMyComputer 
      Height          =   480
      Left            =   3090
      Picture         =   "frmDesktop.frx":1042
      Top             =   4680
      Width           =   480
      Visible         =   0   'False
   End
   Begin VB.Label lblIcon 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "My Computer"
      BeginProperty Font 
         Name            =   "Comic Sans MS"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Index           =   0
      Left            =   0
      MousePointer    =   99  'Custom
      TabIndex        =   1
      Top             =   480
      UseMnemonic     =   0   'False
      Width           =   1185
      Visible         =   0   'False
      WordWrap        =   -1  'True
   End
   Begin VB.Image Image1 
      Height          =   165
      Left            =   450
      Picture         =   "frmDesktop.frx":37E4
      Top             =   4320
      Width           =   165
      Visible         =   0   'False
   End
End
Attribute VB_Name = "frmDesktop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' The icon code is based on duDesk by Lager
'   http://www.pchell.co.uk
' The context menu handling and IShellFolder stuff is based on a example by Brad Martinez
'   http://members.aol.com/btmtz/vb
'   http://www.mvps.org/ccrp
Option Explicit
Dim shortcutx As Boolean
Dim ScaleRatio As Integer
Dim CurrentIndex As Integer
Dim tmpY As Integer
Dim tmpX As Integer
Dim currentIcon As Long
Private Type iconpos
    filename As String
    x As Long
    y As Long
End Type
Dim iconpos() As iconpos
Private Type icon
    IShellFolder As Boolean
    shinfo As SHFILEINFO
    pidlfqChild As Long
    hImgLarge As Long
End Type
Dim icons() As icon
Private Sub Form_GotFocus()

    currentIcon = -1

End Sub
Private Sub Form_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)

    Dim start As String
    Dim i As Long
    
    For i = 1 To Data.Files.Count
        start = Data.Files(i)
        oServer.SetKey Me.Tag, "iconpos" & picIcon.Count, start & "," & x & "," & y
        CopyFS start, x, y
    Next

End Sub
Private Sub Form_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)

    If Data.GetFormat(vbCFFiles) Then
        Effect = vbDropEffectCopy
    Else
        Effect = vbDropEffectNone
    End If

End Sub
Private Sub Form_Paint()

    PaintDesktop Me.hdc

End Sub
Private Sub Form_Unload(Cancel As Integer)

    Dim i As Long
    
    For i = 1 To UBound(icons)
        isMalloc.Free ByVal icons(i).pidlfqChild
    Next i

End Sub
Private Sub picIcon_DblClick(Index As Integer)

    Dim tempstr As String
    
    If icons(Index).IShellFolder Then
        runPIDL (icons(Index).pidlfqChild)
    Else
        oServer.Execute picIcon(Index).Tag
    End If
    
End Sub
Private Sub picIcon_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)

    If Button = vbLeftButton Then
'        picIcon(Index).OLEDrag
        tmpY = y
        tmpX = x
        currentIcon = Index
    End If

End Sub
Private Sub picIcon_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    
    If Index = currentIcon Then
        picIcon(Index).Top = picIcon(Index).Top + (y - tmpY) / ScaleRatio
        picIcon(Index).Left = picIcon(Index).Left + (x - tmpX) / ScaleRatio
        lblIcon(Index).Top = lblIcon(Index).Top + (y - tmpY) / ScaleRatio
        lblIcon(Index).Left = lblIcon(Index).Left + (x - tmpX) / ScaleRatio
    End If

End Sub
Private Sub picIcon_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)

    Dim pt As POINTAPI              ' screen location of the cursor
    Dim isfParent As IShellFolder   ' selected items parent shell folder
    Dim apidlRels As Long           ' the selected items relative pidls (zero based)
    
    If Button = vbLeftButton Then
        saveiconpos
        loadiconpos
        currentIcon = -1
    End If

    If Button = vbRightButton Then
        GetCursorPos pt
        
        If icons(Index).pidlfqChild Then
            ' Get the selected item's parent IShellFolder.
            Set isfParent = GetParentIShellFolder(icons(Index).pidlfqChild)
            If (isfParent Is Nothing) = False Then
            ' Get a copy of the selected item's relative pidl (the last item ID) from its fully qualified pidl.
                apidlRels = GetItemID(icons(Index).pidlfqChild, GIID_LAST)
                If apidlRels Then
                    ' Show the shell context menu for the selected items. If a  menu command was executed, refresh the two listboxes.
                    ShowShellContextMenu Me.hWnd, isfParent, 1, apidlRels, pt
                End If
                Call MemAllocator.Free(ByVal apidlRels)
            End If
        End If
    End If

End Sub
Private Sub lblIcon_DblClick(Index As Integer)

    picIcon_DblClick Index
    
End Sub
Private Sub lblIcon_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)

    picIcon_MouseDown Index, Button, Shift, x, y

End Sub
Private Sub lblIcon_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)

    picIcon_MouseMove Index, Button, Shift, x, y

End Sub
Private Sub lblIcon_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    
    picIcon_MouseUp Index, Button, Shift, x, y

End Sub
Private Sub picIcon_OLECompleteDrag(Index As Integer, Effect As Long)

    If Effect = vbDropEffectMove Then
        Kill picIcon(Index).Tag
        Me.updateDesk
    End If

End Sub
Private Sub picIcon_OLEStartDrag(Index As Integer, Data As DataObject, AllowedEffects As Long)

    If icons(Index).IShellFolder Then
    Else
        Debug.Print "filename=" & picIcon(Index).Tag
        AllowedEffects = vbDropEffectCopy
        Data.Clear
        Data.Files.Add picIcon(Index).Tag
        Data.SetData , vbCFFiles
    End If
        
End Sub
Private Sub picIcon_Paint(Index As Integer)
    
'    Dim i As Integer
'    Dim j As Integer
'    Dim r As Long
'    Dim c As Long
    
'    BitBlt picIcon(Index).hdc, 0, 0, picIcon(Index).Width, picIcon(Index).Height, frmDesktop.hdc, picIcon(Index).Left, picIcon(Index).Top, &HCC0020
    ImageList_Draw icons(Index).hImgLarge, icons(Index).shinfo.iIcon, picIcon(Index).hdc, 0, 0, ILD_TRANSPARENT
'    If Index = currentIcon Then
'        For i = 0 To picIcon(Index).Width
'            For j = 0 To picIcon(Index).Height
'                c = picIcon(Index).Point(i, j)
'                If c >= 0 Then
'                    c = Tint(c, 80)
'                    picIcon(Index).PSet (i, j), c
'                End If
'            Next j
'        Next i
'    End If
    
End Sub
Public Function updateDesk()
    
    Dim i As Integer
    Dim textline As String
    Dim filelist() As String
    Dim sPath As String
    Dim isfParent As IShellFolder         ' parent folder's IShellFolder
    Dim ieidl As IEnumIDList                ' isfParent's enumeration object
    Dim pidlrelChild As Long                ' child folder's pidl, relative to isfParent
    Dim pidlfqChild As Long                ' child folder's fully qualified pidl, relative to the desktop folder
    Dim pidlDesktop As Integer              ' desktop's pidl
    Dim addi As Long
    Dim pidlFQ As Long
    Dim pidlRel As Long
    Dim lblcaption As String
    Dim IconSpacing As Long
    Dim IconVerticalspacing As Long
    
    IconVerticalspacing = GetIconVerticalspacing
    Debug.Print "IconVerticalspacing=" & IconVerticalspacing
    
    If picIcon.Count > 1 Then
        saveiconpos
    End If
    
    ReDim icons(0)
    
    loadiconpos
    
    For i = 1 To picIcon.Count - 1
        Unload picIcon(i)
        Unload lblIcon(i)
    Next
    
    ReDim filelist(0)
    i = 1
  
    ' Initialize the imagelist with an undoc shell call. Is only necessary for
    ' NT4 where the app gets an uninitialized system imagelist copy. See:
    ' http://www.geocities.com/SiliconValley/4942/iconcache.html
    ' **** Call is not exported in stock Win95's Shell32.dll !!! ****
    On Error Resume Next
    Call FileIconInit(True)
    On Error GoTo 0

    pidlFQ = VarPtr(pidlDesktop)
    pidlRel = GetItemID(pidlFQ, GIID_LAST)
    If pidlRel Then
        ' Get the parent's IShellFolder from its fully qualified pidl
        Set isfParent = GetIShellFolder(isfDesktop, pidlFQ)
  
        ' Create an enumeration object for the parent folder.
        If SUCCEEDED(isfParent.EnumObjects(Me.hWnd, SHCONTF_FOLDERS Or SHCONTF_INCLUDEHIDDEN, ieidl)) Then
                                                                
            ' Enumerate the contents of the parent folder
            Do While (ieidl.Next(1, pidlrelChild, 0) = NOERROR)
          
            ' Create a fully qualified pidl for the current child folder.
                pidlfqChild = CombinePIDLs(pidlFQ, pidlrelChild)
                If pidlfqChild Then
                    ' Get the child folder's attributes, specifiy what attributes we want.
                    ReDim Preserve icons(i + 1)
                    icons(i).IShellFolder = True
                    icons(i).pidlfqChild = pidlfqChild
                    icons(i).hImgLarge = SHGetFileInfo(pidlfqChild, 0&, icons(i).shinfo, Len(icons(i).shinfo), SHGFI_PIDL Or SHGFI_SYSICONINDEX Or SHGFI_LARGEICON)
                    Load picIcon(i)
                    Load lblIcon(i)
                    picIcon(i).Tag = GetFolderDisplayName(isfParent, pidlrelChild, SHGDN_INFOLDER)
                    picIcon(i).ToolTipText = picIcon(i).Tag
                    picIcon(i).Top = getIconY(picIcon(i).Tag)
                    picIcon(i).Left = getIconX(picIcon(i).Tag)
                    picIcon(i).Visible = True
                    
                    lblIcon(i).Caption = picIcon(i).Tag
                    lblIcon(i).Top = picIcon(i).Top + picIcon(i).Height
                    lblIcon(i).Left = picIcon(i).Left
                    lblIcon(i).Width = CLng(picIcon(i).Width - (IconVerticalspacing / Screen.TwipsPerPixelX))
                    lblIcon(i).Left = CLng(picIcon(i).Left + (IconVerticalspacing / Screen.TwipsPerPixelX) / 2)
                    lblIcon(i).Visible = True
                    i = i + 1
                    ' Free the current child folder's absolute pidl we created.
                    'isMalloc.Free ByVal pidlfqChild
                End If
          
                ' Free the relative pidl the enumeration gave us.
                isMalloc.Free ByVal pidlrelChild
        
            Loop   ' ieidl.Next
        End If   ' SUCCEEDED(EnumObjects))
    
        Call FreePIDL(pidlRel)
    End If
  
    If fGetSystemFolderPath(hWnd, CSIDL_COMMON_DESKTOPDIRECTORY, sPath) Then
        If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    End If
    textline = Dir(sPath, vbDirectory)
    Do While textline <> ""
        If textline <> "." And textline <> ".." Then
            ReDim Preserve filelist(UBound(filelist) + 1)
            filelist(UBound(filelist)) = sPath & textline
        End If
        textline = Dir
    Loop

    If fGetSystemFolderPath(hWnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
        If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    End If
    textline = Dir(sPath, vbDirectory)
    Do While textline <> ""
        If textline <> "." And textline <> ".." Then
            ReDim Preserve filelist(UBound(filelist) + 1)
            filelist(UBound(filelist)) = sPath & textline
        End If
        textline = Dir
    Loop
    addi = i - 1
    
    For i = 1 To UBound(filelist)
        ReDim Preserve icons(addi + i + 1)
        icons(addi + i).pidlfqChild = GetPIDLFromPath(Me.hWnd, filelist(i))
        icons(addi + i).hImgLarge = SHGetFileInfo(filelist(i), 0&, icons(addi + i).shinfo, Len(icons(addi + i).shinfo), SHGFI_TYPENAME Or SHGFI_SHELLICONSIZE Or SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or SHGFI_EXETYPE Or SHGFI_LARGEICON)
        
        Load picIcon(addi + i)
        Load lblIcon(addi + i)
        picIcon(addi + i).Tag = filelist(i)
        lblcaption = ExtractFileName(filelist(i))
        If Right(lblcaption, 4) = ".lnk" Then
            lblcaption = Left(lblcaption, Len(lblcaption) - 4)
        End If
        lblIcon(addi + i).Caption = lblcaption
        picIcon(addi + i).ToolTipText = lblcaption
        picIcon(addi + i).Top = getIconY(filelist(i))
        picIcon(addi + i).Left = getIconX(filelist(i))
        picIcon(addi + i).Visible = True
        Debug.Print "picIcon.left=" & picIcon(addi + i).Left
        lblIcon(addi + i).Top = picIcon(addi + i).Top + picIcon(addi + i).Height
        lblIcon(addi + i).Left = picIcon(addi + i).Left
        lblIcon(addi + i).Width = CLng(picIcon(addi + i).Width - (IconVerticalspacing / Screen.TwipsPerPixelX))
        lblIcon(addi + i).Left = CLng(picIcon(addi + i).Left + (IconVerticalspacing / Screen.TwipsPerPixelX) / 2)
        Debug.Print "lblIcon.left=" & lblIcon(addi + i).Left
        lblIcon(addi + i).Visible = True
    Next i
    
    currentIcon = -1
    ScaleRatio = Me.Width / Me.ScaleWidth

End Function
Private Function getIconX(filename As String)

    Dim i As Long
    
    i = 1
    While i < UBound(iconpos) And iconpos(i).filename <> filename
        i = i + 1
    Wend
    If i < UBound(iconpos) Then
        getIconX = iconpos(i).x
    Else
        If iconpos(UBound(iconpos)).filename = filename Then
            getIconX = iconpos(UBound(iconpos)).x
        Else
            getIconX = 0
        End If
    End If

End Function
Private Function getIconY(filename As String)

    Dim i As Long
    
    i = 1
    While i < UBound(iconpos) And iconpos(i).filename <> filename
        i = i + 1
    Wend
    If i < UBound(iconpos) Then
        getIconY = iconpos(i).y
    Else
        If iconpos(UBound(iconpos)).filename = filename Then
            getIconY = iconpos(UBound(iconpos)).y
        Else
            getIconY = 0
        End If
    End If

End Function
Private Function GetSpecialFolder(CSIDL As Long) As String
   
   Dim sPath As String
   Dim pidl As Long
   
   If SHGetSpecialFolderLocation(Me.hWnd, CSIDL, pidl) = ERROR_SUCCESS Then
      sPath = Space$(MAX_LENGTH)
      If SHGetPathFromIDList(ByVal pidl, ByVal sPath) Then
         GetSpecialFolder = Left$(sPath, InStr(sPath, Chr$(0)) - 1) & "\"
      End If
   End If

End Function
Public Sub CreateShortcut(filepath As String)
   
    Dim recentpath As String
    Dim i As Long

    If filepath = "" Then Exit Sub
    recentpath = GetSpecialFolder(CSIDL_RECENT)
    If recentpath = "" Then Exit Sub
    Call SHAddToRecentDocs(SHARD_PATH, filepath)
    Dim found As Integer
    Dim shortcut As String
    found = 0
    shortcut = recentpath & ExtractFileName(filepath) & ".lnk"
    For i = 1 To 10
    If Dir(shortcut) <> "" Then
        found = 1
        Exit For
    End If
    Next i
    If found = 0 Then
         MsgBox "Error creating shortcut"
        Exit Sub
    End If
    ShellMoveFiles shortcut

End Sub
Private Sub ShellMoveFiles(sFiles As String)
   
    Dim lret As Long
    Dim fileop As SHFILEOPSTRUCT
    Dim result As Long
    Dim sPath As String

    If fGetSystemFolderPath(hWnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
        If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    End If
    
    With fileop
        .hWnd = 0
        .wFunc = FO_MOVE
        .pFrom = sFiles & vbNullChar & vbNullChar
        .pTo = sPath & vbNullChar & vbNullChar
        .lpszProgressTitle = "Moving..."
        .fFlags = FOF_SIMPLEPROGRESS Or FOF_RENAMEONCOLLISION
    End With

    lret = SHFileOP(fileop)

    If result <> 0 Then 'Operation failed
        oServer.Execute "!log " & Err.LastDllError 'Show the error returned from the API.
    Else
        Me.updateDesk
    End If

End Sub
Public Sub CopyFS(CopyFS As String, x As Single, y As Single)
    
    Dim lret As Long
    Dim fileop As SHFILEOPSTRUCT
    Dim result As Long
    Dim sPath As String

    If fGetSystemFolderPath(hWnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
        If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    End If

    With fileop
        .hWnd = 0
        .wFunc = FO_COPY
        .pFrom = CopyFS & vbNullChar & vbNullChar
        .pTo = sPath & vbNullChar & vbNullChar
        .lpszProgressTitle = "Copying..."
        .fFlags = FOF_SIMPLEPROGRESS Or FOF_RENAMEONCOLLISION
    End With

    lret = SHFileOP(fileop)

    If result <> 0 Then 'Operation failed
        oServer.Execute "!log " & Err.LastDllError 'Show the error returned from the API.
    Else
        Me.updateDesk
    End If
    
End Sub
Public Sub DeleteFS(DelFS As String)
    
    Dim lret As Long
    Dim fileop As SHFILEOPSTRUCT
    Dim result As Long
    Dim sPath As String

    If fGetSystemFolderPath(hWnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
        If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    End If

    With fileop
        .hWnd = 0
        .wFunc = FO_DELETE
        .pFrom = DelFS & vbNullChar & vbNullChar
        .pTo = sPath & vbNullChar & vbNullChar
        .lpszProgressTitle = "Deleting..."
        .fFlags = FOF_SIMPLEPROGRESS Or FOF_RENAMEONCOLLISION
    End With

    lret = SHFileOP(fileop)

    If result <> 0 Then 'Operation failed
        oServer.Execute "!log " & Err.LastDllError 'Show the error returned from the API.
    Else
        Me.updateDesk
    End If
    
End Sub
Public Function ExtractFileName(ByVal strPath As String) As String
    
    If InStr(strPath, "\") Then
        strPath = StrReverse(strPath)
        strPath = Left(strPath, InStr(strPath, "\") - 1)
        ExtractFileName = StrReverse(strPath)
    Else
        ExtractFileName = strPath
    End If

End Function
Public Function FileExists(strPath As String) As Integer
    
    FileExists = Not (Dir(strPath) = "")

End Function
Public Function fGetSystemFolderPath(ByVal hWnd As Long, ByVal Id As Integer, sfPath As String) As Long

    Dim lReturn As Long
    Dim lPidl   As Long
    Dim lPath   As Long
    Dim sPath   As String

    sPath = Space$(MAX_PATH)
    lReturn = SHGetSpecialFolderLocation(hWnd, Id, lPidl)       ' Get lPidl for Id...
    If lReturn = 0 Then                                         ' If success is 0
        lReturn = SHGetPathFromIDList(lPidl, sPath)             ' Get Path from Item Id List
        If lReturn = 1 Then                                     ' If success is 1
            sPath = Trim$(sPath)                                ' Fix path string
            lPath = Len(sPath)                                  ' Get length of path
            If Asc(Right$(sPath, 1)) = 0 Then lPath = lPath - 1 ' Adjust path length
            If lPath > 0 Then sfPath = Left$(sPath, lPath)      ' Adjust path string variable
            fGetSystemFolderPath = True                         ' Return success
        End If
    End If

End Function
Public Sub saveiconpos()

    Dim i As Long
    
    For i = 1 To picIcon.Count - 1
        oServer.SetKey Me.Tag, "iconpos" & i, picIcon(i).Tag & "," & picIcon(i).Left & "," & picIcon(i).Top
    Next i

End Sub
Public Sub loadiconpos()

    Dim i As Long
    Dim textline As String
    
    ReDim iconpos(0)
    i = 1
    textline = oServer.GetKey(Me.Tag, "iconpos" & i)
    While textline <> ""
        ReDim Preserve iconpos(i)
        iconpos(i).filename = Left(textline, InStr(textline, ",") - 1)
        textline = Right(textline, Len(textline) - InStr(textline, ","))
        iconpos(i).x = oServer.evalNum(Left(textline, InStr(textline, ",") - 1))
        iconpos(i).y = oServer.evalNum(Right(textline, Len(textline) - InStr(textline, ",")) - 1)
        i = i + 1
        textline = oServer.GetKey(Me.Tag, "iconpos" & i)
    Wend

End Sub
Private Function CreatePicture(ByVal hImage As Long, Optional ByVal PicType As PictureTypeConstants = vbPicTypeBitmap, Optional Data1 As Long = 0, Optional Data2 As Long = 0) As IPicture
   
    Dim r As Long
    Dim Pic As PictDesc
    Dim ipic As IPicture
    Dim IID_IDispatch As Guid
    
    With IID_IDispatch
       .Data1 = &H20400
       .Data4(0) = &HC0
       .Data4(7) = &H46
    End With
    
    With Pic
       .Size = Len(Pic)
       .Type = PicType
       .hImage = hImage
       .Data1 = Data1
       .Data2 = Data2
    End With
    
    r = OleCreatePictureIndirect(Pic, IID_IDispatch, False, ipic)
    Set CreatePicture = ipic

End Function
'This uses a method suggested at MSKB to
'ensure that all parameters are passed correctly
'Call this wrapper rather than the API function directly
Private Function SHFileOP(ByRef lpFileOp As SHFILEOPSTRUCT) As Long
    Dim result As Long
    Dim lenFileop As Long
    Dim foBuf() As Byte
    
    lenFileop = LenB(lpFileOp)
    ReDim foBuf(1 To lenFileop) 'the size of the structure.
    
    'Now we need to copy the structure into a byte array
    Call CopyMemory(foBuf(1), lpFileOp, lenFileop)
    
    'Next we move the last 12 bytes by 2 to byte align the data
    Call CopyMemory(foBuf(19), foBuf(21), 12)
    result = SHFileOperation(foBuf(1))
    
    SHFileOP = result
End Function
Public Sub runPIDL(m_pidl As Long)

    Dim udtSEI As SHELLEXECUTEINFO
    
    With udtSEI
        .cbSize = Len(udtSEI)
        .fMask = SEE_MASK_UNICODE Or SEE_MASK_FLAG_NO_UI Or SEE_MASK_IDLIST
        .hWnd = Me.hWnd
'        .lpVerb = Null
'        .lpDirectory = Null
'        .lpParameters = Null
'        .hInstApp = Null
'        .lpFile = Null
        
        .lpVerb = 0
        .lpDirectory = 0
        .lpParameters = 0
        .hInstApp = 0
        .nShow = SW_SHOWNORMAL
        .lpFile = 0
        .lpIDList = m_pidl
    End With
   
    Call ShellExecuteEX(udtSEI)

End Sub
