VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Private ml_PIDLDesktop As Long
Dim pidl As Long
Dim hSHNotify As Long
Private ml_NotifyResult As Long
Private m_oForm As Desktop.frmDesktop
Private mWndProcOrg As Long
Private mHWndSubClassed As Long
Private m_sName As String
Private rDesk(1) As RECT
Private lHwnd As Long
Private WinNT As Boolean
Private inProc As Boolean
Public Function GetMyWndProc(ByVal lWndProc As Long) As Long
    
    GetMyWndProc = lWndProc
    
End Function
Public Function IBasePlugin_StartPlugin(name As String) As Long
    
    Dim OSINFO As OSVERSIONINFO
    
    OSINFO.dwOSVersionInfoSize = 148
    OSINFO.szCSDVersion = Space$(128)
    GetVersionEx OSINFO
          
    If OSINFO.dwPlatformId = 2 Then
        WinNT = True
    Else
        WinNT = False
    End If
    
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang name, "!createshortcut"
    oServer.RegisterBang name, "!refresh"
    
    rDesk(0).Right = GetSystemMetrics(SM_CXSCREEN)
    rDesk(0).Bottom = GetSystemMetrics(SM_CYSCREEN)
    
    rDesk(1).Bottom = oServer.GetKey(name, "Bottom")
    rDesk(1).Left = oServer.GetKey(name, "Left")
    rDesk(1).Top = oServer.GetKey(name, "Top")
    rDesk(1).Right = oServer.GetKey(name, "Right")
    
    SetDesktopArea rDesk(1)
    
    Set m_oForm = New Desktop.frmDesktop
    Load m_oForm
   
    m_oForm.Top = rDesk(1).Top * Screen.TwipsPerPixelY
    m_oForm.Left = rDesk(1).Left * Screen.TwipsPerPixelX
    m_oForm.Width = (rDesk(1).Right - rDesk(1).Left) * Screen.TwipsPerPixelX
    m_oForm.Height = (rDesk(1).Bottom - rDesk(1).Top) * Screen.TwipsPerPixelY
    
    m_sName = name
    m_oForm.Tag = name
    
    If GetAsyncKeyState(vbKeyShift) = 0 Then
        If oServer.evalBool(oServer.GetKey(name, "runonce")) Then
            StartUp True
        End If
        
        If oServer.evalBool(oServer.GetKey(name, "run")) Then
            StartUp False
        End If
        
        If oServer.evalBool(oServer.GetKey(name, "startup")) Then
        
            Dim sPath As String
            Dim textline As String
            
            If fGetSystemFolderPath(m_oForm.hWnd, CSIDL_STARTUP, sPath) Then
            
                textline = Dir(sPath & "\*.*")
                While textline <> ""
                    oServer.Execute "!log Starting " & textline
                    oServer.Execute sPath & "\" & textline
                    textline = Dir
                Wend
            
            End If
        
            If fGetSystemFolderPath(m_oForm.hWnd, CSIDL_COMMON_STARTUP, sPath) Then
            
                textline = Dir(sPath & "\*.*")
                While textline <> ""
                    oServer.Execute "!log Starting " & textline
                    oServer.Execute sPath & "\" & textline
                    textline = Dir
                Wend
            
            End If
        
        End If
    Else
        oServer.Execute "!log skiping startup items (shift pressed)"
    End If
    
    SubClass
    If oServer.evalBool(oServer.GetKey(name, "showicons")) Then
        m_oForm.updateDesk
        If Not SHNotify_Register(m_oForm.hWnd) Then
            oServer.Execute "!log failed to start watching the desktop folder"
        End If
    End If
    oServer.SetDesktop m_oForm.hWnd
    oServer.Execute "!log Registered " & name & " as the desktop window"
    SetWindowPos m_oForm.hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOSIZE Or SWP_NOMOVE Or SWP_NOACTIVATE Or SWP_NOSENDCHANGING
    ShowWindow m_oForm.hWnd, SW_SHOWNOACTIVATE
    IBasePlugin_StartPlugin = m_oForm.hWnd

End Function
Private Sub IBasePlugin_StopPlugin()
    
    m_oForm.saveiconpos
    m_oForm.Visible = False
    SHNotify_Unregister
    UnSubClass
    Call Unload(m_oForm)
    Set m_oForm = Nothing

End Sub
Public Sub IBasePlugin_Bang(ByVal name As String, ByVal Arguments As String)

    Dim sPath As String
    
    Select Case name
    Case "!createshortcut"
        If fGetSystemFolderPath(m_oForm.hWnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
            Shell "rundll32.exe AppWiz.Cpl,NewLinkHere " & sPath, 1
        End If
    Case "!refresh"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.updateDesk
        End If
    End Select
   
End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Private Sub SubClass()
   '-------------------------------------------------------------
   'Initiates the subclassing of this UserControl's window (hwnd).
   'Records the original WinProc of the window in mWndProcOrg.
   'Places a pointer to the object in the window's UserData area.
   '-------------------------------------------------------------

   'Exit if the window is already subclassed.
   If mWndProcOrg Then Exit Sub

      'Redirect the window's messages from this control's default
      'Window Procedure to the SubWndProc function in your .BAS
      'module and record the address of the previous Window
      'Procedure for this window in mWndProcOrg.
      mWndProcOrg = SetWindowLong(m_oForm.hWnd, GWL_WNDPROC, AddressOf SubWndProc)

      'Record your window handle in case SetWindowLong gave you a
      'new one. You will need this handle so that you can unsubclass.
      mHWndSubClassed = m_oForm.hWnd

      'Store a pointer to this object in the UserData section of
      'this window that will be used later to get the pointer to
      'the control based on the handle (hwnd) of the window getting
      'the message.
      Call SetWindowLong(m_oForm.hWnd, GWL_USERDATA, ObjPtr(Me))

End Sub
Private Sub UnSubClass()
   
   '-----------------------------------------------------------
   'Unsubclasses this UserControl's window (hwnd), setting the
   'address of the Windows Procedure back to the address it was
   'at before it was subclassed.
   '-----------------------------------------------------------

   'Ensures that you don't try to unsubclass the window when
   'it is not subclassed.
   If mWndProcOrg = 0 Then Exit Sub

   'Reset the window's function back to the original address.
   SetWindowLong mHWndSubClassed, GWL_WNDPROC, mWndProcOrg
   '0 Indicates that you are no longer subclassed.
   mWndProcOrg = 0

End Sub
Public Function HIWORD(dw As Long) As Integer

    If dw And &H80000000 Then
        HIWORD = (dw \ 65535) - 1
    Else
        HIWORD = dw \ 65535
    End If

End Function
Public Function LOWORD(dw As Long) As Integer

    If dw And &H8000& Then
        LOWORD = &H8000 Or (dw And &H7FFF&)
    Else
        LOWORD = dw And &HFFFF&
    End If

End Function
Private Function SHNotify_Register(hWnd As Long) As Boolean
  
    Dim sPath As String
    Dim ps As PIDLSTRUCT
    
    If fGetSystemFolderPath(hWnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
        If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    End If
    
    If WinNT Then
       pidl = SHSimpleIDListFromPath(StrConv(sPath, vbUnicode))
    Else
       pidl = SHSimpleIDListFromPath(sPath)
    End If
    
    ps.pidl = pidl
    ps.bWatchSubFolders = True
    SHNotify_Register = CBool(SHChangeNotifyRegister(hWnd, SHCNF_TYPE Or SHCNF_IDLIST, SHCNE_ALLEVENTS Or SHCNE_INTERRUPT, WM_SHNOTIFY, 1, ps))

    If WinNT Then
        If fGetSystemFolderPath(hWnd, CSIDL_COMMON_DESKTOPDIRECTORY, sPath) Then
            If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
        End If
        
        pidl = SHSimpleIDListFromPath(StrConv(sPath, vbUnicode))
        
        ps.pidl = pidl
        ps.bWatchSubFolders = True
        SHNotify_Register = SHNotify_Register And CBool(SHChangeNotifyRegister(hWnd, SHCNF_TYPE Or SHCNF_IDLIST, SHCNE_ALLEVENTS Or SHCNE_INTERRUPT, WM_SHNOTIFY, 1, ps))
    End If

End Function
Private Function SHNotify_Unregister() As Boolean
  
    If ml_NotifyResult Then
        If SHChangeNotifyDeregister(ml_NotifyResult) Then
            ml_NotifyResult = 0
            Call CoTaskMemFree(ml_PIDLDesktop)
            ml_PIDLDesktop = 0
            SHNotify_Unregister = True
        End If
    End If

End Function
Private Function GetPIDLFromFolderID(hOwner As Long, nFolder As SHSpecialFolderIDs) As Long
    
    Dim pidl As Long
    
    If SHGetSpecialFolderLocation(hOwner, nFolder, pidl) = NOERROR Then
        GetPIDLFromFolderID = pidl
    End If

End Function
Private Function GetDisplayNameFromPIDL(pidl As Long) As String
  
    Dim sfib As SHFILEINFO
    
    If SHGetFileInfo(pidl, 0, sfib, Len(sfib), SHGFI_PIDL Or SHGFI_DISPLAYNAME) Then
        GetDisplayNameFromPIDL = GetStrFromBufferA(StrConv(sfib.szDisplayName, vbUnicode))
    End If

End Function
Private Function GetPathFromPIDL(pidl As Long) As String
  
    Dim sPath As String * MAX_PATH
    
    If SHGetPathFromIDList(pidl, sPath) Then   ' rtns TRUE (1) if successful, FALSE (0) if not
        GetPathFromPIDL = GetStrFromBufferA(sPath)
    End If

End Function
Private Function GetStrFromBufferA(sz As String) As String
  
    If InStr(sz, vbNullChar) Then
        GetStrFromBufferA = Left$(sz, InStr(sz, vbNullChar) - 1)
    Else
        GetStrFromBufferA = sz
    End If

End Function
Friend Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

   '--------------------------------------------------------------
   'Process the window's messages that are sent to your UserControl.
   'The WindowProc function is declared as a "Friend" function so
   'that the .BAS module can call the function but the function
   'cannot be seen from outside the UserControl project.
   '--------------------------------------------------------------

    
    Dim WP As WINDOWPOS
    Dim sCommand As String
    Dim shns As SHNOTIFYSTRUCT
    Dim ml_dwItem1 As Long
    Dim ms_DisplayName As String
    Dim ms_DisplayName2 As String
    Dim ps As PAINTSTRUCT
    Dim hdc As Long

    Select Case uMsg
        Case WM_DISPLAYCHANGE
            rDesk(0).Right = LOWORD(lParam)
            rDesk(0).Bottom = HIWORD(lParam)
            SetWindowPos lHwnd, HWND_BOTTOM, 0, 0, rDesk(0).Right, rDesk(0).Bottom, SWP_NOACTIVATE
            Exit Function

        Case WM_WINDOWPOSCHANGING
            CopyMemorySrcAddr WP, lParam, LenB(WP)
            WP.hWndInsertAfter = HWND_BOTTOM
            CopyMemoryDestAddr lParam, WP, LenB(WP)
            WindowProc = 0
            Exit Function

'        Case WM_ERASEBKGND
'            PaintDesktop CLng(wParam)
'            WindowProc = 1
'            Exit Function

'        Case WM_PAINT
'            hdc = BeginPaint(m_oForm.hwnd, ps)
'            PaintDesktop hdc
'            EndPaint m_oForm.hwnd, ps
'            WindowProc = 0
        
        Case WM_CLOSE
            oServer.Execute "!shutdown"
            WindowProc = 0
            Exit Function

        Case WM_SYSCOMMAND
            If wParam = SC_CLOSE Then
                oServer.Execute "!shutdown"
                WindowProc = 0
                Exit Function
            End If

        Case WM_LBUTTONDOWN
            sCommand = oServer.GetKey(m_oForm.Tag, "lbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_LBUTTONUP
            sCommand = oServer.GetKey(m_oForm.Tag, "lbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_LBUTTONDBLCLK
            sCommand = oServer.GetKey(m_oForm.Tag, "lbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_RBUTTONDOWN
            sCommand = oServer.GetKey(m_oForm.Tag, "rbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_RBUTTONUP
            sCommand = oServer.GetKey(m_oForm.Tag, "rbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_RBUTTONDBLCLK
            sCommand = oServer.GetKey(m_oForm.Tag, "rbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_MBUTTONDOWN
            sCommand = oServer.GetKey(m_oForm.Tag, "mbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_MBUTTONUP
            sCommand = oServer.GetKey(m_oForm.Tag, "mbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_MBUTTONDBLCLK
            sCommand = oServer.GetKey(m_oForm.Tag, "mbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            WindowProc = 0
            Exit Function

        Case WM_INITMENUPOPUP, WM_DRAWITEM, WM_MEASUREITEM
            If (ICtxMenu2 Is Nothing) = False Then
                Call ICtxMenu2.HandleMenuMsg(uMsg, wParam, lParam)
            End If
            WindowProc = 0
            Exit Function

        Case WM_SHNOTIFY
            MoveMemory shns, ByVal wParam, Len(shns)
            If lParam = SHCNE_UPDATEDIR Then
                m_oForm.updateDesk
            End If

        Case WM_CHILDACTIVATE, WM_NCACTIVATE, WM_SETFOCUS, WM_KILLFOCUS, WM_ACTIVATEAPP, WM_ACTIVATE, WM_PARENTNOTIFY
            SetWindowPos lHwnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOSIZE
    End Select
  
    'Forwards the window's messages that came in to the original
    'Window Procedure that handles the messages and returns
    'the result back to the SubWndProc function.
    WindowProc = CallWindowProc(mWndProcOrg, hWnd, uMsg, wParam, lParam)


End Function
